import { defineComponent as b, ref as g, watch as m, nextTick as k, onMounted as D, onBeforeUnmount as V, createBlock as M, openBlock as B, Transition as T, withCtx as _, withDirectives as N, createElementVNode as y, normalizeStyle as $, normalizeClass as C, withModifiers as E, createElementBlock as h, createCommentVNode as O, renderSlot as S, vShow as H } from "vue";
const I = ["aria-describedby"], P = { role: "document" }, z = /* @__PURE__ */ b({
  __name: "HtmlDialog",
  props: {
    modelValue: Boolean,
    showBackdrop: { type: Boolean, default: !0 },
    closeOnBackdropClick: { type: Boolean, default: !0 },
    closeOnOutsideClick: { type: Boolean, default: !0 },
    closeOnEscape: { type: Boolean, default: !0 },
    showCloseButton: { type: Boolean, default: !0 },
    titleId: String,
    dialogClass: String,
    backdropClass: String,
    closeButtonClass: String,
    enterActiveClass: { type: String, default: "fade-enter-active" },
    leaveActiveClass: { type: String, default: "fade-leave-active" },
    transitionDuration: { type: Number, default: 300 }
  },
  emits: ["update:modelValue", "open", "close"],
  setup(c, { expose: f, emit: s }) {
    const o = c, l = g(null), n = g(o.modelValue), d = typeof HTMLDialogElement < "u", i = s;
    m(() => o.modelValue, (e) => {
      n.value = e;
    }), m(n, (e) => {
      var r;
      e ? k(() => {
        k(() => {
          l.value && !l.value.open && (l.value.showModal(), l.value.focus());
        });
      }) : (r = l.value) == null || r.close();
    }), m(n, (e) => {
      e ? (window.addEventListener("keydown", v), !o.showBackdrop && o.closeOnOutsideClick && document.addEventListener("mousedown", a)) : (window.removeEventListener("keydown", v), document.removeEventListener("mousedown", a));
    }), m(() => o.modelValue, (e) => {
      e ? p() : u();
    });
    function p() {
      d && l.value && l.value.showModal ? (n.value = !0, k(() => {
        k(() => {
          l.value && l.value.showModal ? (l.value.showModal(), i("open")) : (console.warn("HTMLDialogElement is not supported in this browser."), i("open"));
        });
      })) : (n.value = !0, i("open"));
    }
    function u() {
      var e;
      (e = l.value) == null || e.close(), i("update:modelValue", !1), i("close");
    }
    function w(e) {
      e.target === e.currentTarget && o.closeOnBackdropClick && u();
    }
    function t() {
      n.value = !1, i("update:modelValue", !1), i("close");
    }
    function a(e) {
      if (!l.value || !o.closeOnOutsideClick) return;
      const r = l.value, L = e.target;
      r.contains(L) || u();
    }
    function v(e) {
      e.key === "Escape" && o.closeOnEscape && u();
    }
    return D(() => {
      l.value && (n.value = o.modelValue, l.value.addEventListener("close", t));
    }), V(() => {
      var e;
      window.removeEventListener("keydown", v), document.removeEventListener("mousedown", a), (e = l.value) == null || e.removeEventListener("close", t), n.value = !1;
    }), f({
      openDialog: p,
      closeDialog: u
    }), (e, r) => (B(), M(T, {
      "enter-active-class": e.enterActiveClass,
      "leave-active-class": e.leaveActiveClass,
      onAfterLeave: r[1] || (r[1] = (L) => e.$emit("close"))
    }, {
      default: _(() => [
        N(y("div", {
          class: C(["backdrop", e.backdropClass]),
          onMousedown: w,
          role: "presentation",
          style: $({ "--transition-duration": e.transitionDuration + "ms" })
        }, [
          y("dialog", {
            ref_key: "dialogEl",
            ref: l,
            class: C(["dialog", e.dialogClass]),
            onPointerdown: r[0] || (r[0] = E(() => {
            }, ["stop"])),
            role: "dialog",
            "aria-modal": "true",
            "aria-describedby": e.titleId
          }, [
            y("div", P, [
              e.showCloseButton ? (B(), h("button", {
                key: 0,
                class: C(["close-button", e.closeButtonClass]),
                onPointerdown: E(u, ["prevent"]),
                "aria-label": "Close the modal"
              }, "×", 34)) : O("", !0),
              S(e.$slots, "default", {}, void 0, !0)
            ])
          ], 42, I)
        ], 38), [
          [H, n.value && e.showBackdrop]
        ])
      ]),
      _: 3
    }, 8, ["enter-active-class", "leave-active-class"]));
  }
}), A = (c, f) => {
  const s = c.__vccOpts || c;
  for (const [o, l] of f)
    s[o] = l;
  return s;
}, j = /* @__PURE__ */ A(z, [["__scopeId", "data-v-a75a1e01"]]), F = { role: "document" }, K = /* @__PURE__ */ b({
  __name: "FullNativeDialog",
  props: {
    modelValue: Boolean,
    closeOnEscape: { type: Boolean, default: !0 },
    closeButton: { type: Boolean, default: !0 },
    dialogClass: String,
    closeButtonClass: String,
    enterActiveClass: { type: String, default: "fade-enter-active" },
    leaveActiveClass: { type: String, default: "fade-leave-active" },
    transitionDuration: { type: Number, default: 300 }
  },
  emits: ["update:modelValue", "open", "close"],
  setup(c, { emit: f }) {
    const s = c, o = g(null), l = g(!1), n = g(null), d = f;
    function i() {
      o.value && (o.value.open || (o.value.showModal(), d("update:modelValue", !0), d("open"), o.value.focus()));
    }
    function p() {
      !o.value || l.value || (l.value = !0, o.value.classList.add(s.leaveActiveClass), setTimeout(() => {
        var t, a;
        (t = o.value) == null || t.close(), l.value = !1, (a = o.value) == null || a.classList.remove(s.leaveActiveClass), d("update:modelValue", !1), d("close");
      }, s.transitionDuration));
    }
    m(
      () => s.modelValue,
      (t) => {
        var a;
        t ? (i(), n.value && clearTimeout(n.value), (a = o.value) == null || a.classList.add(s.enterActiveClass), n.value = window.setTimeout(() => {
          var v;
          (v = o.value) == null || v.classList.remove(s.enterActiveClass), n.value = null;
        }, s.transitionDuration)) : p();
      }
    );
    function u(t) {
      s.closeOnEscape || t.preventDefault();
    }
    function w() {
      d("update:modelValue", !1), d("close");
    }
    return D(() => {
      var t, a;
      (t = o.value) == null || t.addEventListener("cancel", u), (a = o.value) == null || a.addEventListener("close", w);
    }), V(() => {
      var t, a;
      (t = o.value) == null || t.removeEventListener("cancel", u), (a = o.value) == null || a.removeEventListener("close", w);
    }), (t, a) => (B(), h("dialog", {
      ref_key: "dialogEl",
      ref: o,
      class: C([t.dialogClass]),
      role: "dialog",
      onPointerdown: a[0] || (a[0] = E(() => {
      }, ["stop"])),
      "aria-modal": "true"
    }, [
      y("div", F, [
        t.closeButton ? (B(), h("button", {
          key: 0,
          class: C(["close-button", t.closeButtonClass]),
          onPointerdown: E(p, ["prevent"]),
          "aria-label": "Close dialog",
          type: "button"
        }, "×", 34)) : O("", !0),
        S(t.$slots, "default", {}, void 0, !0)
      ])
    ], 34));
  }
}), q = /* @__PURE__ */ A(K, [["__scopeId", "data-v-6c2d8e9f"]]);
export {
  q as FullNativeDialog,
  j as HtmlDialog
};
